## racket 7.9+dfsg1

=== src/cs/Makefile ===
# This makefile is used to a limited degree with nmake, but it mostly
# intended for use as a GNU makefile.

RACKET = ../../bin/racket
SCHEME = scheme

# Controls whether Racket layers are built as unsafe; beware that
# building some Racket libraries using safe mode may require setting
# `PLT_CS_COMPILE_LIMIT` to 1000 (instead of 10000):
UNSAFE_COMP = --unsafe

# Controls whether compiled code is compressed:
COMPRESS_COMP = # --compress

# Controls whether Racket layers are built with expression-level
# debugging; use "--debug" for expression-level information or
# "--srcloc" for procedure-level source locations:
DEBUG_COMP = # --debug

# For cross-compiling, set `CROSS_COMP` to `-m <machine>`, where
# the Chez Scheme directory must have "<machine>/s/xpatch":
CROSS_COMP =

# Can be set by a caller:
EXTRA_COMPILE_DEPS = 

COMPILE_FILE = $(SCHEME) --script compile-file.ss $(UNSAFE_COMP) $(COMPRESS_COMP) $(DEBUG_COMP) $(CROSS_COMP) --dest "$(BUILDDIR)"
COMPILE_FILE_DEPS = compile-file.ss include.ss place-register.ss $(EXTRA_COMPILE_DEPS)

RACKET_SETUP_ARGS = false ../../bin/racket ../../bin/racket ../collects ../etc 0 false false 0 ""

PRIMITIVES_TABLES = primitive/kernel.ss primitive/unsafe.ss primitive/flfxnum.ss \
                    primitive/paramz.ss primitive/extfl.ss primitive/network.ss \
                    primitive/futures.ss primitive/foreign.ss primitive/place.ss \
                    primitive/linklet.ss primitive/internal.ss

# Set by the makefile in the "c" directory when driving this one
BUILDDIR =

# Set by the makefile in the "c" directory when driving this one to
# avoid trying to re-build bootstrapped files:
BOOTSTRAPPED = schemified

# List all targets ".scm" that use "convert.rkt" so we can generate a
# dependency rule for all of them:
CONVERTED = schemified/thread.scm schemified/io.scm \
            schemified/regexp.scm schemified/expander.scm \
            schemified/schemify.scm schemified/known.scm

# Additional dependencies for those ".scm" files generated by "convert.rkt":
CONVERT_DEPS = $(PRIMITIVES_TABLES)

CONVERT_RACKET = $(RACKET) -l- setup --chain ../setup-go.rkt $(BUILDDIR)compiled
CONVERT = $(CONVERT_RACKET) '(CONVERTED)' $(BUILDDIR)compiled/convert.d convert.rkt $(UNSAFE_COMP)

# This extension is for libraries, and it changes for cross builds:
CSO = so

# Depenency chain for ".so" files:
RUMBLE_DEPS = $(BUILDDIR)chezpart.$(CSO)
THREAD_DEPS = $(RUMBLE_DEPS) $(BUILDDIR)rumble.$(CSO)
IO_DEPS = $(THREAD_DEPS) $(BUILDDIR)thread.$(CSO)
REGEXP_DEPS = $(IO_DEPS) $(BUILDDIR)io.$(CSO)
SCHEMIFY_DEPS = $(REGEXP_DEPS) $(BUILDDIR)regexp.$(CSO)
LINKLET_DEPS = $(SCHEMIFY_DEPS) $(BUILDDIR)schemify.$(CSO)
EXPANDER_DEPS = $(LINKLET_DEPS) $(BUILDDIR)linklet.$(CSO)
MAIN_DEPS = $(EXPANDER_DEPS) $(BUILDDIR)expander.$(CSO)

converted: $(CONVERTED)

all:
	$(MAKE) rktio
	$(MAKE) rktl
	$(MAKE) $(BUILDDIR)racket.so

CROSS_TARGET = all
cross:
	$(MAKE) $(CROSS_TARGET) CSO=$(HOST) CROSS_COMP="--xpatch $(XPATCH)"

expander-demo: $(BUILDDIR)expander.$(CSO) demo/expander.ss ../../bin/racket
	$(SCHEME) $(EXPANDER_DEPS) $(BUILDDIR)expander.$(CSO) demo/expander.ss

run: $(BUILDDIR)main.so ../../bin/racket
	$(SCHEME) --script $(BUILDDIR)main.so $(RACKET_SETUP_ARGS) $(ARGS)

setup:
	$(MAKE) run ARGS="-l- setup $(ARGS)"

setup-v:
	$(MAKE) run ARGS="-W 'info@compiler/cm info@linklet debug@GC:major error' -l- setup -j 1 $(ARGS)"

run-wpo: $(BUILDDIR)racket.so ../../bin/racket
	$(SCHEME) --script $(BUILDDIR)racket.so $(RACKET_SETUP_ARGS) $(ARGS)

$(BUILDDIR)racket.so: $(BUILDDIR)main.so $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) --whole-program $(BUILDDIR)racket.so $(BUILDDIR)main.wpo

MAIN_SRCS = main/help.ss

$(BUILDDIR)main.so: $(MAIN_DEPS) main.sps $(MAIN_SRCS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) main.sps $(MAIN_DEPS)

strip:
	$(SCHEME) --script strip.ss $(MAIN_DEPS) $(BUILDDIR)racket.so

rktl:
	$(MAKE) thread-rktl
	$(MAKE) io-rktl
	$(MAKE) regexp-rktl
	$(MAKE) schemify-rktl
	$(MAKE) known-rktl
	$(MAKE) expander-rktl

# For running without an enclosing build of the traditional Racket VM:
../../bin/racket:
	mkdir -p ../../bin
	touch ../../bin/racket

$(BUILDDIR)expander.$(CSO): expander.sls expander/env.ss schemified/expander.scm $(PRIMITIVES_TABLES) $(EXPANDER_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) expander.sls $(EXPANDER_DEPS)

$(BOOTSTRAPPED)/expander.scm: $(BUILDDIR)compiled/expander.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/expander.rktl $(BOOTSTRAPPED)/expander.scm

$(BUILDDIR)compiled/expander.rktl:
	$(MAKE) expander-rktl

expander-rktl:
	$(MAKE) bounce BOUNCE_DIR=../expander BOUNCE_TARGET=expander-src BUILDDIR="../cs/"

linklet-demo: $(BUILDDIR)linklet.$(CSO)
	$(SCHEME) $(LINKLET_DEPS) $(BUILDDIR)linklet.$(CSO) demo/linklet.ss

LINKLET_SRCS = linklet/version.ss \
               linklet/read.ss \
               linklet/write.ss \
               linklet/check.ss \
               linklet/performance.ss \
               linklet/annotation.ss \
               linklet/compress.ss \
               linklet/cross-compile.ss

$(BUILDDIR)linklet.$(CSO): linklet.sls $(LINKLET_SRCS) $(LINKLET_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) linklet.sls $(LINKLET_DEPS)


$(BUILDDIR)schemify.$(CSO): schemify.sls schemified/schemify.scm schemified/known.scm $(SCHEMIFY_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) schemify.sls $(SCHEMIFY_DEPS)

$(BOOTSTRAPPED)/schemify.scm: $(BUILDDIR)compiled/schemify.rktl $(CONVERT_DEPS)
	$(CONVERT) --skip-export $(BUILDDIR)compiled/schemify.rktl $(BOOTSTRAPPED)/schemify.scm

$(BUILDDIR)compiled/schemify.rktl:
	$(MAKE) schemify-rktl

schemify-rktl:
	$(MAKE) bounce BOUNCE_DIR=../schemify BOUNCE_TARGET=schemify-src BUILDDIR="../cs/"


# Used by schemify.sls at compile time
$(BOOTSTRAPPED)/known.scm: $(BUILDDIR)compiled/known.rktl $(CONVERT_DEPS)
	$(CONVERT) --skip-export $(BUILDDIR)compiled/known.rktl $(BOOTSTRAPPED)/known.scm

$(BUILDDIR)compiled/known.rktl:
	$(MAKE) known-rktl

known-rktl:
	$(MAKE) bounce BOUNCE_DIR=../schemify BOUNCE_TARGET=known-src BUILDDIR="../cs/"


regexp-demo: $(BUILDDIR)regexp.$(CSO)
	$(SCHEME) $(REGEXP_DEPS) $(BUILDDIR)regexp.$(CSO) demo/regexp.ss

$(BUILDDIR)regexp.$(CSO): schemified/regexp.scm regexp.sls $(REGEXP_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) regexp.sls $(REGEXP_DEPS)

$(BOOTSTRAPPED)/regexp.scm: $(BUILDDIR)compiled/regexp.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/regexp.rktl $(BOOTSTRAPPED)/regexp.scm

$(BUILDDIR)compiled/regexp.rktl:
	$(MAKE) regexp-rktl

regexp-rktl:
	$(MAKE) bounce BOUNCE_DIR=../regexp BOUNCE_TARGET=regexp-src BUILDDIR="../cs/"


io-demo: $(BUILDDIR)io.$(CSO)
	$(SCHEME) $(IO_DEPS) $(BUILDDIR)io.$(CSO) demo/io.ss

$(BUILDDIR)io.$(CSO): schemified/io.scm io.sls $(IO_DEPS) ../rktio/rktio.rktl $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) io.sls $(IO_DEPS)

$(BOOTSTRAPPED)/io.scm: $(BUILDDIR)compiled/io.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/io.rktl $(BOOTSTRAPPED)/io.scm

$(BUILDDIR)compiled/io.rktl:
	$(MAKE) io-rktl

io-rktl:
	$(MAKE) bounce BOUNCE_DIR=../io BOUNCE_TARGET=io-src BUILDDIR="../cs/"

rktio:
	$(MAKE) bounce BOUNCE_DIR=../io BOUNCE_TARGET=rktio


thread-demo: $(BUILDDIR)thread.$(CSO)
	$(SCHEME) $(THREAD_DEPS) $(BUILDDIR)thread.$(CSO) demo/thread.ss

$(BUILDDIR)thread.$(CSO): schemified/thread.scm thread.sls $(THREAD_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) thread.sls $(THREAD_DEPS)

$(BOOTSTRAPPED)/thread.scm: $(BUILDDIR)compiled/thread.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/thread.rktl $(BOOTSTRAPPED)/thread.scm

$(BUILDDIR)compiled/thread.rktl:
	$(MAKE) thread-rktl

thread-rktl:
	$(MAKE) bounce BOUNCE_DIR=../thread BOUNCE_TARGET=thread-src BUILDDIR="../cs/"


bounce:
	$(MAKE) bounce-go RACKET="`$(RACKET) absify.rkt --exec $(RACKET)`"

bounce-go:
	cd $(BOUNCE_DIR); $(MAKE) RACO="$(RACKET) -N raco -l- raco" $(BOUNCE_TARGET)


chaperone-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/chaperone.ss

hash-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/hash.ss

struct-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/struct.ss

control-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/control.ss

foreign-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/foreign.ss

will-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/will.ss

future-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/future.ss

future2-demo: $(BUILDDIR)rumble.$(CSO)
	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/future2.ss

RUMBLE_SRCS = rumble/define.ss \
              rumble/virtual-register.ss \
              rumble/layout.ss \
              rumble/check.ss \
	      rumble/syntax-rule.ss \
              rumble/constant.ss \
              rumble/hash-code.ss \
              rumble/struct.ss \
              rumble/prefab.ss \
              rumble/procedure.ss \
              rumble/impersonator.ss \
              rumble/equal.ss \
              rumble/object-name.ss \
              rumble/arity.ss \
              rumble/intmap.ss \
              rumble/patricia.ss \
              rumble/hamt-stencil.ss \
              rumble/hamt-vector.ss \
              rumble/hash.ss \
              rumble/datum.ss \
	      rumble/lock.ss \
	      rumble/thread-local.ss \
              rumble/thread-cell.ss \
              rumble/parameter.ss \
              rumble/begin0.ss \
              rumble/value.ss \
              rumble/pthread.ss \
              rumble/control.ss \
              rumble/interrupt.ss \
              rumble/engine.ss \
              rumble/source.ss \
              rumble/error.ss \
              rumble/error-rewrite.ss \
              rumble/srcloc.ss \
              rumble/boolean.ss \
              rumble/bytes.ss \
              rumble/string.ss \
              rumble/char.ss \
              rumble/char-range.ss \
              rumble/symbol.ss \
              rumble/list.ss \
              rumble/vector.ss \
              rumble/box.ss \
              rumble/immutable.ss \
              rumble/keyword.ss \
              rumble/mpair.ss \
              rumble/number.ss \
              rumble/random.ss \
              rumble/flvector.ss \
              rumble/correlated.ss \
              rumble/graph.ss \
              rumble/time.ss \
              rumble/memory.ss \
              rumble/ephemeron.ss \
              rumble/will-executor.ss \
              rumble/system.ss \
              rumble/unsafe.ss \
              rumble/extfl.ss \
              rumble/place.ss \
              rumble/errno-data.ss \
              rumble/foreign.ss \
              rumble/async-callback.ss \
              rumble/future.ss \
              rumble/version.ss \
              rumble/inline.ss \
              ../version/racket_version.h

$(BUILDDIR)rumble.$(CSO): $(RUMBLE_DEPS) rumble.sls $(RUMBLE_SRCS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) rumble.sls $(RUMBLE_DEPS)

$(BUILDDIR)chezpart.$(CSO): chezpart.sls $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) chezpart.sls

clean:
	rm -f chezpart.$(CSO) rumble.$(CSO) regexp.$(CSO) io.$(CSO) linklet.$(CSO) expander.$(CSO) schemify.$(CSO)
	rm -f chezpart.so rumble.so regexp.so io.so linklet.so expander.so schemify.so
	rm -f chezpart.wpo rumble.wpo regexp.wpo io.wpo linklet.wpo expander.wpo schemify.wpo
	rm -f thread.$(CSO) thread.wpo main.wpo main.so
	rm -rf compiled


# The following included dependency files are generated by when
# creating compiler/expander.rktl, etc. The `-inclide` statements are
# wrapped in a pattern that causes them to be ignored by `nmake`,
# while the `nmake` directives are ignored by GNU `make`.

# \
!if 0

# These dependencies are used only for direct use of the makefile
-include compiled/expander.d
-include compiled/thread.d
-include compiled/io.d

=== src/schemify/Makefile ===
# This makefile can be used directly or driven by other makefiles.
# See "../expander/Makefile" for more notes.

RACKET = ../../bin/racket
RACO = $(RACKET) -N raco -l- raco

# Ignoring functions from `#%read` works because they won't appear in
# the simplified expansion. Make annotation references direct to
# improve performance. Declaring "collect.rkt" pure works around a
# limitation of the flattener.
IGNORE = ++knot read - ++direct kernel ++pure ../../collects/racket/private/collect.rkt

schemify-src:
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) schemify-src-generate

known-src:
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) known-src-generate


S_GENERATE_ARGS = -t main.rkt \
                  --check-depends $(BUILDDIR)compiled/schemify-dep.rktd \
                  ++depend-module ../expander/bootstrap-run.rkt \
                  --depends $(BUILDDIR)compiled/schemify-dep.rktd \
                  --makefile-depends $(DEPENDSDIR)compiled/schemify.rktl $(BUILDDIR)compiled/schemify.d \
                  -c $(BUILDDIR)compiled/cache-src \
                  -k ../.. $(IGNORE) -s -x \
                  -o $(BUILDDIR)compiled/schemify.rktl

schemify-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(S_GENERATE_ARGS)


K_GENERATE_ARGS = -t known.rkt \
                  --check-depends $(BUILDDIR)compiled/known-dep.rktd \
                  ++depend-module ../expander/bootstrap-run.rkt \
                  --depends $(BUILDDIR)compiled/known-dep.rktd \
                  --makefile-depends $(DEPENDSDIR)compiled/known.rktl $(BUILDDIR)compiled/known.d \
                  -c $(BUILDDIR)compiled/cache-src \
                  -k ../.. $(IGNORE) -s -x \
                  -o $(BUILDDIR)compiled/known.rktl


known-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(K_GENERATE_ARGS)

.PHONY: schemify-src schemify-src-generate known-src known-src-generate

=== src/thread/Makefile ===
# This makefile can be used directly or driven by other makefiles.
# See "../expander/Makefile" for more notes.

RACKET = ../../bin/racket
RACO = $(RACKET) -N raco -l- raco

thread-src:
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) thread-src-generate

# When flattening, replace a dynamic lookup from a primitive table to
# a direct use of the primitive name:
DIRECT = ++direct pthread

# Make sure that the flattened form doesn't use `error`:
DISALLOW = ++disallow error

# Enable the sanity check for global state (to be avoided in
# favor of place-local state), but declare some initialized-once
# global state to be ok:
GLOBALS = --no-global \
          ++global-ok the-sandman \
          ++global-ok post-shutdown-action \
          ++global-ok get-subprocesses-time \
          ++global-ok pre-poll-callbacks \
          ++global-ok queued-shutdowns \
          ++global-ok compute-memory-sizes \
          ++global-ok "computed-memory-sizes?" \
          ++global-ok custodians-with-limits \
          ++global-ok make-place-ports+fds \
          ++global-ok pthread-count \
          ++global-ok "logging-future-events?" \
          ++global-ok log-future-event \
          ++global-ok "logging-place-events?" \
          ++global-ok log-place-event \
          ++global-ok thread-engine-for-roots

GENERATE_ARGS = -t main.rkt \
                --check-depends $(BUILDDIR)compiled/thread-dep.rktd \
                ++depend-module ../expander/bootstrap-run.rkt \
                --depends $(BUILDDIR)compiled/thread-dep.rktd \
                --makefile-depends $(DEPENDSDIR)compiled/thread.rktl $(BUILDDIR)compiled/thread.d \
                -c $(BUILDDIR)compiled/cache-src \
                -k ../.. -s -x $(DIRECT) $(DISALLOW) $(GLOBALS) \
                -o $(BUILDDIR)compiled/thread.rktl

# This target can be used with a `RACKET` that builds via `-l- setup --chain ...`
thread-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(GENERATE_ARGS)

demo:
	$(RACO) make demo.rkt
	$(RACKET) demo.rkt

.PHONY: thread-src thread-src-generate demo

=== src/ChezScheme/bintar/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

version = 9.5.3
m := $(shell find ../bin/* -type d | xargs basename)

R = csv$(version)
TARBALL = $(R)-$(m).tar.gz

CONTENTS=\
  $(R)/LICENSE\
  $(R)/NOTICE\
  $(R)/scheme.1.in\
  $(R)/installsh\
  $(R)/Makefile\
  $(R)/examples\
  $(R)/boot\
  $(R)/bin

$(TARBALL): $(CONTENTS)
	( BROKEN=`find -L $R -type l` ; \
          if test -n "$$BROKEN" ; then \
             echo "Error: missing $(BROKEN)" ; \
             exit 1 ; \
          fi )
	tar -czhf $(TARBALL) $R
	rm -rf $(R) 

$(R)/LICENSE: $(R)
	( cd $(R) ; ln -s ../../../LICENSE . )

$(R)/NOTICE: $(R)
	( cd $(R) ; ln -s ../../../NOTICE . )

$(R)/scheme.1.in: $(R)
	( cd $(R) ; ln -s ../../scheme.1.in . )

$(R)/installsh: $(R)
	( cd $(R) ; ln -s ../../installsh . )

$(R)/Makefile: $(R)
	( cd $(R) ; ln -s ../../Mf-install Makefile )

$(R)/examples: $(R)
	( cd $(R) ; ln -s ../../examples . )

$(R)/boot: $(R)
	mkdir -p $(R)/boot/$(m)
	( cd $(R)/boot/$(m) ; ln -s ../../../../boot/$(m)/{scheme.h,petite.boot,scheme.boot,revision} . )
	case $(m) in \
          *nt) \
            ( cd $R/boot/$(m) ; ln -s ../../../../boot/$(m)/{csv953md.lib,csv953mt.lib,mainmd.obj,mainmt.obj,scheme.res} . ) \
            ;; \
          *) \
            ( cd $R/boot/$(m) ; ln -s ../../../../boot/$(m)/{main.o,kernel.o} . ) \
            ;; \
        esac

$(R)/bin: $(R)
	mkdir -p $(R)/bin/$(m)
	case $(m) in \
          *nt) \
            ( cd $R/bin/$(m) ; ln -s ../../../../bin/$(m)/{scheme.exe,csv953.dll,csv953.lib,vcruntime140.lib} . ) \
            ;; \
          *) \
            ( cd $R/bin/$(m) ; ln -s ../../../../bin/$(m)/scheme . ) \
            ;; \
        esac

$(R):
	mkdir $(R)

clean:
	rm -rf $(R) $(TARBALL)

=== src/ChezScheme/examples/Makefile ===
# Unix make file to compile the examples.
# Compilation is not necessary since the examples may be loaded from
# source, but this gives an example of how to use make for Scheme.
# * To compile files not already compiled, type "make".  Only those
#   files in the object list below and not yet compiled will be compiled.
# * To compile all files, type "make all".  Only those files in the object
#   list below will be compiled.
# * To compile one file, say "fumble.ss", type "make fumble.so".  The
#   file need not be in the object list below.
# * To remove the object files, type "make clean".
# * To print the examples, type "make print".

src = def.ss edit.ss fact.ss fatfib.ss fft.ss fib.ss freq.ss interpret.ss\
 m4.ss macro.ss matrix.ss object.ss power.ss queue.ss rabbit.ss rsa.ss\
 scons.ss setof.ss socket.ss unify.ss compat.ss ez-grammar-test.ss
obj = ${src:%.ss=%.so}

Scheme = ../bin/scheme -q

.SUFFIXES:
.SUFFIXES: .ss .so
.ss.so: ; echo '(time (compile-file "$*"))' | ${Scheme}

needed:	${obj}

all: ; echo "(time (for-each compile-file (map symbol->string '(${src}))))" | ${Scheme}

clean: ; /bin/rm -f $(obj) expr.md

=== src/ChezScheme/pkg/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

m := $(shell find ../bin/* -type d | xargs basename)
version = 9.5.3
release = 1

DOTUSER = $(shell ls -ld . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
DOTGROUP = $(shell ls -ldg . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
BUILDROOT = $(m)$(version)
RELEASE = csv$(version)
TARBALL = $(RELEASE)-$(m).tar.gz
PKG = $(RELEASE)-$(m)-$(release).pkg

PKGCONTENT =\
 $(BUILDROOT)/Resources/en.lproj/Welcome.html\
 $(BUILDROOT)/Resources/en.lproj/License.txt\
 $(BUILDROOT)/Distribution\
 $(BUIDROOT)/Root/bin\
 $(BUILDROOT)/Root/lib\
 $(BUILDROOT)/Root/man

$(PKG): $(BUILDROOT)/$(PKG)
	sudo /usr/bin/productbuild\
          --resources $(BUILDROOT)/Resources\
          --distribution $(BUILDROOT)/Distribution\
          --package-path $(BUILDROOT)\
          $(PKG)
	sudo chown $(DOTUSER):$(DOTGROUP) $(PKG)
	sudo /bin/rm -rf $(RELEASE) $(BUILDROOT)

$(BUILDROOT)/$(PKG): $(PKGCONTENT)
	sudo /usr/bin/pkgbuild\
          --root $(BUILDROOT)/Root\
          --identifier chezscheme\
          --version $(version)\
          --install-location /\
          --ownership recommended\
          $(BUILDROOT)/$(PKG)

$(BUILDROOT)/Distribution: $(BUILDROOT)
	echo '<?xml version="1.0" encoding="utf-8" standalone="no"?>' > $(BUILDROOT)/Distribution
	echo '<installer-gui-script minSpecVersion="1">' >> $(BUILDROOT)/Distribution
	echo '    <pkg-ref id="chezscheme">' >> $(BUILDROOT)/Distribution
	echo '        <bundle-version/>' >> $(BUILDROOT)/Distribution
	echo '    </pkg-ref>' >> $(BUILDROOT)/Distribution
	echo '    <title>Chez Scheme</title>' >> $(BUILDROOT)/Distribution
	echo '    <welcome file="Welcome.html"/>' >> $(BUILDROOT)/Distribution
	echo '    <license file="License.txt"/>' >> $(BUILDROOT)/Distribution
	echo '    <options customize="never" rootVolumeOnly="true"/>' >> $(BUILDROOT)/Distribution
	echo '    <options customize="never" require-scripts="false"/>' >> $(BUILDROOT)/Distribution
	echo '    <choices-outline>' >> $(BUILDROOT)/Distribution
	echo '        <line choice="default">' >> $(BUILDROOT)/Distribution
	echo '            <line choice="chezscheme"/>' >> $(BUILDROOT)/Distribution
	echo '        </line>' >> $(BUILDROOT)/Distribution
	echo '    </choices-outline>' >> $(BUILDROOT)/Distribution
	echo '    <choice id="default"/>' >> $(BUILDROOT)/Distribution
	echo '    <choice id="chezscheme" visible="false">' >> $(BUILDROOT)/Distribution
	echo '        <pkg-ref id="chezscheme"/>' >> $(BUILDROOT)/Distribution
	echo '    </choice>' >> $(BUILDROOT)/Distribution
	echo '    <pkg-ref id="chezscheme" version="$(version)" onConclusion="none" installKBytes="1639">#$(PKG)</pkg-ref>' >> $(BUILDROOT)/Distribution
	echo '</installer-gui-script>' >> $(BUILDROOT)/Distribution
	chmod 644 $(BUILDROOT)/Distribution

$(BUILDROOT)/Resources/en.lproj/Welcome.html: $(BUILDROOT)/Resources/en.lproj
	echo '<html>' > $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<h3>Chez Scheme Version $(version)</h3>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<p>Copyright &copy; 2019 Cisco Systems, Inc.</p>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '<p>Chez Scheme is a programming language and an implementation of that language, with supporting tools and documentation.</p>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	echo '</html>' >> $(BUILDROOT)/Resources/en.lproj/Welcome.html
	chmod 644 $(BUILDROOT)/Resources/en.lproj/Welcome.html

$(BUILDROOT)/Resources/en.lproj/License.txt: $(BUILDROOT)/Resources/en.lproj
	cat ../../NOTICE ../../LICENSE > $(BUILDROOT)/Resources/en.lproj/License.txt
	chmod 644 $(BUILDROOT)/Resources/en.lproj/License.txt

$(BUILDROOT)/Resources/en.lproj: $(BUILDROOT)/Resources
	install -d $(BUILDROOT)/Resources/en.lproj

$(BUILDROOT)/Resources: $(BUILDROOT)
	install -d $(BUILDROOT)/Resources

$(BUIDROOT)/Root/bin $(BUILDROOT)/Root/lib $(BUILDROOT)/Root/man: $(BUILDROOT)/Root $(RELEASE)
	( cd $(RELEASE); sudo make install InstallGroup=wheel TempRoot=../$(BUILDROOT)/Root )

$(BUILDROOT)/Root: $(BUILDROOT)
	install -d $(BUILDROOT)/Root

$(RELEASE): $(BUILDROOT) ../bintar/$(TARBALL)
	tar -xzf ../bintar/$(TARBALL)

$(BUILDROOT):
	install -d $(BUILDROOT)

clean:
	rm -rf $(PKG) $(BUILDROOT) $(RELEASE)

=== src/ChezScheme/rpm/Makefile ===
# Makefile
# Copyright 1984-2017 Cisco Systems, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

version = 9.5.3
release = 1
m := $(shell find ../bin/* -type d | xargs basename)
arch := $(shell if test "$(m)" == "i3le" ; then echo i686 ; elif test "$(m)" == "a6le" ; then echo x86_64 ; else echo UNKNOWN ; fi)
DOTUSER := $(shell ls -ld . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
DOTGROUP := $(shell ls -ldg . | sed -e 's/[^ ]* *[^ ]* *\([^ ]*\).*/\1/')
TMP := $(shell pwd)/tmp
SPEC = $(TMP)/ChezScheme-$(version)-$(arch)-$(release).spec
RELEASE = csv$(version)
TARBALL = $(RELEASE)-$(m).tar.gz
RPM = ChezScheme-$(version)-$(release).$(arch).rpm


$(RPM): $(TMP)/$(RPM)
	sudo install -m 644 -o $(DOTUSER) -g $(DOTGROUP) $(TMP)/${RPM} .

$(TMP)/$(RPM): $(SPEC) $(TMP)/$(TARBALL)
	sudo setarch $(arch) rpmbuild\
          --target $(arch)\
          --define "_topdir $(TMP)" \
          --define "_srcrpmdir $(TMP)" \
          --define "_rpmdir $(TMP)" \
          --define "_sourcedir $(TMP)" \
          --define "_builddir $(TMP)" \
          --define "_rpmfilename %{NAME}-%{VERSION}-%{RELEASE}.%{ARCH}.rpm" \
          --quiet -ba $(SPEC)

$(SPEC): $(TMP)
	echo 'Summary: Chez Scheme: A high-performance version of Scheme' > $(SPEC)
	echo 'Name: ChezScheme' >> $(SPEC)
	echo 'Version: $(version)' >> $(SPEC)
	echo 'Release: $(release)' >> $(SPEC)
	echo 'Provides: ChezScheme-runtime-{VERSION}' >> $(SPEC)
	echo 'License: Apache 2.0' >> $(SPEC)
	echo 'URL: http://github.com/cisco/chezscheme' >> $(SPEC)
	echo 'Group: Development/Languages' >> $(SPEC)
	echo 'Source0: $(TARBALL)' >> $(SPEC)
	echo 'BuildRoot: %{_tmppath}/%{name}' >> $(SPEC)
	echo '%description' >> $(SPEC)
	echo 'Chez Scheme is a programming language and an implementation of that language,' >> $(SPEC)
	echo 'with supporting tools and documentation.' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%prep' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%setup -T -b 0 -n $(RELEASE)' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '#%build' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%install' >> $(SPEC)
	echo 'make install TempRoot=%{buildroot}' >> $(SPEC)
	echo '' >> $(SPEC)
	echo '%files' >> $(SPEC)
	echo '#%doc NOTICE' >> $(SPEC)
	echo '#%doc LICENSE' >> $(SPEC)
	echo '/usr/lib/$(RELEASE)' >> $(SPEC)
	echo '/usr/bin/petite' >> $(SPEC)
	echo '/usr/bin/scheme' >> $(SPEC)
	echo '/usr/bin/scheme-script' >> $(SPEC)
	echo '/usr/share/man/man1/petite.1.gz' >> $(SPEC)
	echo '/usr/share/man/man1/scheme.1.gz' >> $(SPEC)

$(TMP)/$(TARBALL): $(TMP) ../bintar/$(TARBALL)
	cp ../bintar/$(TARBALL) $(TMP)

$(TMP):
	mkdir $(TMP)

clean:
	rm -rf $(TMP) $(RPM)

=== src/ChezScheme/stex/Makefile ===
VERSION=1.2

# override PREFIX, Scheme, and LIB as necessary
PREFIX=/usr

# scheme executable
Scheme=$(PREFIX)/bin/scheme

# target location for stex
LIB=$(PREFIX)/lib/stex$(VERSION)

m := $(shell echo '(machine-type)' | $(Scheme) -q)

Install=./sbin/install

exec = $m/scheme-prep $m/html-prep $m/fixbibtex

all: $(exec)

$m/scheme-prep: src/dsm.ss src/preplib.ss src/script.ss src/scheme-prep.ss
	if [ ! -d $m ] ; then mkdir $m ; fi
	sed -e 's;^#! /usr/bin/scheme --program;#! $(Scheme) --program;' src/scheme-prep.ss > $m/scheme-prep.ss
	echo '(reset-handler abort) (library-directories (quote "src::$m")) (compile-imported-libraries #t) (generate-wpo-files #t) (compile-program "$m/scheme-prep.ss") (compile-whole-program "$m/scheme-prep.wpo" "$m/scheme-prep")' | $(Scheme) -q
	chmod 755 $m/scheme-prep

$m/html-prep: src/dsm.ss src/preplib.ss src/script.ss src/html-prep.ss
	if [ ! -d $m ] ; then mkdir $m ; fi
	sed -e 's;^#! /usr/bin/scheme --program;#! $(Scheme) --program;' src/html-prep.ss > $m/html-prep.ss
	echo '(reset-handler abort) (library-directories (quote "src::$m")) (compile-imported-libraries #t) (generate-wpo-files #t) (compile-program "$m/html-prep.ss") (compile-whole-program "$m/html-prep.wpo" "$m/html-prep")' | $(Scheme) -q
	chmod 755 $m/html-prep

$m/fixbibtex: src/fixbibtex.ss
	-if [ ! -d $m ] ; then mkdir $m ; fi
	sed -e 's;^#! /usr/bin/scheme --program;#! $(Scheme) --program;' src/fixbibtex.ss > $m/fixbibtex.ss
	echo '(reset-handler abort) (library-directories (quote "src::$m")) (compile-imported-libraries #t) (generate-wpo-files #t) (compile-program "$m/fixbibtex.ss") (compile-whole-program "$m/fixbibtex.wpo" "$m/fixbibtex")' | $(Scheme) -q
	chmod 755 $m/fixbibtex

install: $(exec)
	$(Install) -o root -g root -m 755 -d $(LIB)
	$(Install) -o root -g root -m 755 -d $(LIB)/inputs
	$(Install) -o root -g root -m 644 inputs/* $(LIB)/inputs
	$(Install) -o root -g root -m 755 -d $(LIB)/gifs
	$(Install) -o root -g root -m 644 gifs/* $(LIB)/gifs
	$(Install) -o root -g root -m 755 -d $(LIB)/math
	$(Install) -o root -g root -m 644 math/* $(LIB)/math
	$(Install) -o root -g root -m 755 -d $(LIB)/$m
	$(Install) -o root -g root -m 644 $(exec) $(LIB)/$m
	(umask 022; sed -e 's;^LIB=.*;LIB=$(LIB);' Mf-stex > $(LIB)/Mf-stex)
	(umask 022; sed -e 's;include ~/stex/Mf-stex;include $(LIB)/Mf-stex;' Makefile.template > $(LIB)/Makefile.template)

uninstall:
	/bin/rm -rf $(LIB)

clean:
	/bin/rm -f Make.out

distclean: clean
	/bin/rm -rf $m

=== src/ChezScheme/wininstall/Makefile ===
VERSION := 9.5.3
WIXEXTENSIONS := -ext WixUIExtension -ext WixBalExtension
export MSYS_NO_PATHCONV=1

ChezScheme.exe: x86/bundle.wixobj ChezScheme32.msi ChezScheme64.msi
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $< -out $@

ChezScheme32.msi: x86/product.wixobj x86/examples.wixobj x86/i3nt.wixobj x86/ti3nt.wixobj x86/vcredist.wixobj x86/ui.wixobj
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out "$@"

ChezScheme64.msi: x64/product.wixobj x64/a6nt.wixobj x64/examples.wixobj x64/ta6nt.wixobj x64/vcredist.wixobj x64/ui.wixobj
	cmd.exe /c light.bat -nologo $(WIXEXTENSIONS) $^ -sice:ICE64 -sice:ICE03 -sice:ICE82 -sice:ICE61 -out "$@"

x86/%.wixobj: %.wxs
	cmd.exe /c candle.bat -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@

x64/%.wixobj: %.wxs
	cmd.exe /c candle.bat -arch x64 -nologo -dVersion=$(VERSION) $(WIXEXTENSIONS) $< -out $@

vcredist.wxs: locate-vcredist.bat
	cmd.exe /c locate-vcredist.bat

.PHONY: workareas
workareas:
	cd ..; ./configure -m=a6nt; $(MAKE) -C a6nt
	cd ..; ./configure -m=i3nt; $(MAKE) -C i3nt
	cd ..; ./configure -m=ta6nt; $(MAKE) -C ta6nt
	cd ..; ./configure -m=ti3nt; $(MAKE) -C ti3nt

.PHONY: clean
clean:
	-rm -rf *.msi *.wixpdb x86/ x64/ vcredist.wxs *.wixobj *.exe

=== src/worksp/cs/Makefile ===

INCS = /I.. /I..\..\rktio /I..\librktio /I..\..\worksp\cs /I$(SCHEME_DIR)\$(MACHINE)\boot\$(MACHINE)

RKTIO_LIB = ..\..\build\librktio.lib
BASE_WIN32_LIBS = WS2_32.lib Shell32.lib User32.lib Winmm.lib
WIN32_LIBS = $(BASE_WIN32_LIBS) RpCrt4.lib Ole32.lib Advapi32.lib
SCHEME_LIB_FULL = $(SCHEME_DIR)\$(MACHINE)\boot\$(MACHINE)\$(SCHEME_LIB)

LIBS = $(RKTIO_LIB) \
       $(SCHEME_LIB_FULL) \
       $(WIN32_LIBS)

DEST_DLL = ..\..\build\raw_libracketcs.dll
DEST = ..\..\build\raw_racketcs.exe
GDEST = ..\..\build\raw_gracketcs.exe
CSDIR = ..\..\cs\c

MAIN_DEPS = ..\..\start\config.inc \
            ..\..\start\parse_cmdl.inc \
            ..\..\start\cmdl_to_argv.inc \
            ..\..\start\delayed.inc \
            ..\..\start\win_single.inc \
            ..\..\start\embedded_dll.inc

MEMMOD = ..\..\start\MemoryModule.c

FLAGS = /DWIN32 /Ox /MT
COMP_SUBDIR = /DCS_COMPILED_SUBDIR=1

all: $(DEST) $(GDEST)

$(DEST_DLL): $(CSDIR)\boot.c libracket.res $(RKTIO_LIB) $(SCHEME_LIB_FULL)
	cl /LD /DLL /Fe$(DEST_DLL) $(FLAGS) $(INCS) $(CSDIR)\boot.c libracket.res $(LIBS)

libracket.res: libracket.rc
	rc /l 0x409 /folibracket.res libracket.rc

$(DEST): $(CSDIR)\main.c $(MAIN_DEPS) $(MEMMOD) $(DEST_DLL) racket.res
	cl /Fe$(DEST) $(COMP_SUBDIR) $(FLAGS) $(INCS) $(CSDIR)\main.c $(MEMMOD) racket.res $(WIN32_LIBS)

racket.res: ../racket/racket.rc ../racket/racket.ico
	rc /l 0x409 /foracket.res ../racket/racket.rc

$(GDEST): $(CSDIR)\grmain.c $(CSDIR)\main.c $(MAIN_DEPS) $(DEST_DLL) gracket.res
	cl /Fe$(GDEST) $(COMP_SUBDIR) $(FLAGS) $(INCS) $(CSDIR)\grmain.c $(MEMMOD) gracket.res $(WIN32_LIBS)

gracket.res: ../gracket/gracket.rc ../gracket/gracket.ico
	rc /l 0x409 /fogracket.res ../gracket/gracket.rc

# Useful for debugging:

RKTIO_DLL = ..\..\lib\librktio.dll

rktio-dll:
	cl /Fe$(RKTIO_DLL) /LD $(RKTIO_LIB) $(BASE_WIN32_LIBS) ..\..\rktio\rktio.def /link /machine:x64

=== src/ChezScheme/lz4/lib/Makefile ===
# ################################################################
# LZ4 library - Makefile
# Copyright (C) Yann Collet 2011-2016
# All rights reserved.
#
# This Makefile is validated for Linux, macOS, *BSD, Hurd, Solaris, MSYS2 targets
#
# BSD license
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice, this
#   list of conditions and the following disclaimer in the documentation and/or
#   other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# You can contact the author at :
#  - LZ4 source repository : https://github.com/Cyan4973/lz4
#  - LZ4 forum froup : https://groups.google.com/forum/#!forum/lz4c
# ################################################################

# Version numbers
LIBVER_MAJOR_SCRIPT:=`sed -n '/define LZ4_VERSION_MAJOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./lz4.h`
LIBVER_MINOR_SCRIPT:=`sed -n '/define LZ4_VERSION_MINOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./lz4.h`
LIBVER_PATCH_SCRIPT:=`sed -n '/define LZ4_VERSION_RELEASE/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < ./lz4.h`
LIBVER_SCRIPT:= $(LIBVER_MAJOR_SCRIPT).$(LIBVER_MINOR_SCRIPT).$(LIBVER_PATCH_SCRIPT)
LIBVER_MAJOR := $(shell echo $(LIBVER_MAJOR_SCRIPT))
LIBVER_MINOR := $(shell echo $(LIBVER_MINOR_SCRIPT))
LIBVER_PATCH := $(shell echo $(LIBVER_PATCH_SCRIPT))
LIBVER  := $(shell echo $(LIBVER_SCRIPT))

BUILD_SHARED:=yes
BUILD_STATIC:=yes

OS ?= $(shell uname)
CPPFLAGS+= -DXXH_NAMESPACE=LZ4_
CFLAGS  ?= -O3
DEBUGFLAGS:= -Wall -Wextra -Wcast-qual -Wcast-align -Wshadow \
             -Wswitch-enum -Wdeclaration-after-statement -Wstrict-prototypes \
             -Wundef -Wpointer-arith -Wstrict-aliasing=1
CFLAGS  += $(DEBUGFLAGS) $(MOREFLAGS)
FLAGS    = $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)

SRCFILES := $(sort $(wildcard *.c))


# OS X linker doesn't support -soname, and use different extension
# see : https://developer.apple.com/library/mac/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html
ifeq ($(OS), Darwin)
	SHARED_EXT = dylib
	SHARED_EXT_MAJOR = $(LIBVER_MAJOR).$(SHARED_EXT)
	SHARED_EXT_VER = $(LIBVER).$(SHARED_EXT)
	SONAME_FLAGS = -install_name $(libdir)/liblz4.$(SHARED_EXT_MAJOR) -compatibility_version $(LIBVER_MAJOR) -current_version $(LIBVER)
else
	SONAME_FLAGS = -Wl,-soname=liblz4.$(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT = so
	SHARED_EXT_MAJOR = $(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT_VER = $(SHARED_EXT).$(LIBVER)
endif

ifneq (,$(filter Windows%,$(OS)))
LIBLZ4 = liblz4-$(LIBVER_MAJOR)
else
LIBLZ4 = liblz4.$(SHARED_EXT_VER)
endif

.PHONY: default
default: lib-release

lib-release: DEBUGFLAGS :=
lib-release: lib

lib: liblz4.a liblz4

all: lib

all32: CFLAGS+=-m32
all32: all

ifeq ($(V), 1)
Q =
else
Q = @
endif

liblz4.a: $(SRCFILES)
ifeq ($(BUILD_STATIC),yes)  # can be disabled on command line
	@echo compiling static library
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c $^
	$(Q)$(AR) rcs $@ *.o
endif

$(LIBLZ4): $(SRCFILES)
ifeq ($(BUILD_SHARED),yes)  # can be disabled on command line
	@echo compiling dynamic library $(LIBVER)
ifneq (,$(filter Windows%,$(OS)))
	$(Q)$(CC) $(FLAGS) -DLZ4_DLL_EXPORT=1 -shared $^ -o dll/$@.dll -Wl,--out-implib,dll/liblz4.lib
else
	$(Q)$(CC) $(FLAGS) -shared $^ -fPIC -fvisibility=hidden $(SONAME_FLAGS) -o $@
	@echo creating versioned links
	$(Q)ln -sf $@ liblz4.$(SHARED_EXT_MAJOR)
	$(Q)ln -sf $@ liblz4.$(SHARED_EXT)
endif
endif

liblz4: $(LIBLZ4)

clean:
	$(Q)$(RM) core *.o liblz4.pc dll/liblz4.dll dll/liblz4.lib
	$(Q)$(RM) *.a *.$(SHARED_EXT) *.$(SHARED_EXT_MAJOR) *.$(SHARED_EXT_VER)
	@echo Cleaning library completed


#-----------------------------------------------------------------------------
# make install is validated only for Linux, OSX, BSD, Hurd and Solaris targets
#-----------------------------------------------------------------------------
ifneq (,$(filter $(shell uname),Linux Darwin GNU/kFreeBSD GNU OpenBSD FreeBSD NetBSD DragonFly SunOS Haiku MidnightBSD MINGW32_NT-6.1 MINGW64_NT-6.1 MINGW32_NT-10.0 MINGW64_NT-10.0))

.PHONY: listL120
listL120:  # extract lines >= 120 characters in *.{c,h}, by Takayuki Matsuoka (note : $$, for Makefile compatibility)
	find . -type f -name '*.c' -o -name '*.h' | while read -r filename; do awk 'length > 120 {print FILENAME "(" FNR "): " $$0}' $$filename; done

DESTDIR     ?=
# directory variables : GNU conventions prefer lowercase
# see https://www.gnu.org/prep/standards/html_node/Makefile-Conventions.html
# support both lower and uppercase (BSD), use lower in script
PREFIX      ?= /usr/local
prefix      ?= $(PREFIX)
EXEC_PREFIX ?= $(prefix)
exec_prefix ?= $(EXEC_PREFIX)
BINDIR      ?= $(exec_prefix)/bin
bindir      ?= $(BINDIR)
LIBDIR      ?= $(exec_prefix)/lib
libdir      ?= $(LIBDIR)
INCLUDEDIR  ?= $(prefix)/include
includedir  ?= $(INCLUDEDIR)

ifneq (,$(filter $(OS),OpenBSD FreeBSD NetBSD DragonFly MidnightBSD))
PKGCONFIGDIR ?= $(prefix)/libdata/pkgconfig
else
PKGCONFIGDIR ?= $(libdir)/pkgconfig
endif
pkgconfigdir ?= $(PKGCONFIGDIR)

ifneq (,$(filter $(OS),SunOS))
INSTALL ?= ginstall
else
INSTALL ?= install
endif

INSTALL_PROGRAM ?= $(INSTALL)
INSTALL_DATA    ?= $(INSTALL) -m 644

liblz4.pc: liblz4.pc.in Makefile
	@echo creating pkgconfig
	$(Q)sed -e 's|@PREFIX@|$(prefix)|' \
         -e 's|@LIBDIR@|$(libdir)|' \
         -e 's|@INCLUDEDIR@|$(includedir)|' \
         -e 's|@VERSION@|$(LIBVER)|' \
          $< >$@

install: lib liblz4.pc
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(pkgconfigdir)/ $(DESTDIR)$(includedir)/ $(DESTDIR)$(libdir)/ $(DESTDIR)$(bindir)/
	$(Q)$(INSTALL_DATA) liblz4.pc $(DESTDIR)$(pkgconfigdir)/
	@echo Installing libraries
ifeq ($(BUILD_STATIC),yes)
	$(Q)$(INSTALL_DATA) liblz4.a $(DESTDIR)$(libdir)/liblz4.a
	$(Q)$(INSTALL_DATA) lz4frame_static.h $(DESTDIR)$(includedir)/lz4frame_static.h
endif
ifeq ($(BUILD_SHARED),yes)
# Traditionnally, one installs the DLLs in the bin directory as programs
# search them first in their directory. This allows to not pollute system
# directories (like c:/windows/system32), nor modify the PATH variable.
ifneq (,$(filter Windows%,$(OS)))
	$(Q)$(INSTALL_PROGRAM) dll/$(LIBLZ4).dll $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) dll/liblz4.lib $(DESTDIR)$(libdir)
else
	$(Q)$(INSTALL_PROGRAM) liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)
	$(Q)ln -sf liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT_MAJOR)
	$(Q)ln -sf liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT)
endif
endif
	@echo Installing headers in $(includedir)
	$(Q)$(INSTALL_DATA) lz4.h $(DESTDIR)$(includedir)/lz4.h
	$(Q)$(INSTALL_DATA) lz4hc.h $(DESTDIR)$(includedir)/lz4hc.h
	$(Q)$(INSTALL_DATA) lz4frame.h $(DESTDIR)$(includedir)/lz4frame.h
	@echo lz4 libraries installed

uninstall:
	$(Q)$(RM) $(DESTDIR)$(pkgconfigdir)/liblz4.pc
ifneq (,$(filter Windows%,$(OS)))
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(LIBLZ4).dll
	$(Q)$(RM) $(DESTDIR)$(libdir)/liblz4.lib
else
	$(Q)$(RM) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT)
	$(Q)$(RM) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT_MAJOR)
	$(Q)$(RM) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT_VER)
endif
	$(Q)$(RM) $(DESTDIR)$(libdir)/liblz4.a
	$(Q)$(RM) $(DESTDIR)$(includedir)/lz4.h
	$(Q)$(RM) $(DESTDIR)$(includedir)/lz4hc.h
	$(Q)$(RM) $(DESTDIR)$(includedir)/lz4frame.h
	$(Q)$(RM) $(DESTDIR)$(includedir)/lz4frame_static.h
	@echo lz4 libraries successfully uninstalled

endif

=== src/ChezScheme/stex/doc/Makefile ===
# define default document pathname here
# override on command line with 'make x=newdoc'
x = stex

# define latex processor: latex or pdflatex
latex = pdflatex

# define stex macro files here
stexmacrofiles = 

# list bibliography files here
bib =

# define index if an index is to be generated
# index=yes

include ~/stex/Mf-stex

# define or override suffixes here

# define any additional targets here

# define any dependencies here

# define cleanup targets here:

$(x).clean:
	-rm -f $x.rawsst

$(x).reallyclean:

$(x).reallyreallyclean:

=== debian/changelog ===
racket (7.9+dfsg1-2) unstable; urgency=medium

  * Bug fix: "CVE-2021-32773", thanks to Moritz Mühlenhoff (Closes:
    #991327). Backport commit aa2e814a02 from racket 8.2. See also
    https://github.com/racket/racket/issues/3923

 -- David Bremner <bremner@debian.org>  Sat, 24 Jul 2021 11:13:09 -0300

racket (7.9+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Adjust include path in racket-arch.c (thanks to Asumu Takikawa)

 -- David Bremner <bremner@debian.org>  Tue, 08 Dec 2020 20:47:19 -0400

=== debian/control ===
Source: racket
Section: lisp
Priority: optional
Maintainer: David Bremner <bremner@debian.org>
Standards-Version: 4.1.1
Build-Depends: cdbs, debhelper (>= 10), patchutils, libffi-dev,
 libfreetype6-dev, libjpeg-dev, libpango1.0-dev, libpng-dev, libssl-dev,
 libxaw7-dev, xbitmaps, libxft-dev, libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev, libx11-dev, libxrender-dev, libcairo2-dev,
 sqlite3
Vcs-Git: https://salsa.debian.org/bremner/racket
Vcs-Browser: https://salsa.debian.org/bremner/racket
Homepage: https://www.racket-lang.org/

Package: racket
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, racket-common (= ${source:Version})
Recommends: racket-doc (>= ${source:Upstream-Version}),
            libglib2.0-0, libpangocairo-1.0-0, libjpeg62-turbo, libpng16-16,
            libgtk2.0-0, libgdk-pixbuf2.0-0, libssl1.1
Breaks: plt-scheme (<<5.0~)
Replaces: plt-scheme (<<5.0~)
Provides: plt-scheme
Description: extensible programming language in the Scheme family
 Racket (previously PLT Scheme) is a programming language suitable for
 scripting and application development, including GUIs and web
 services.
 .
 It supports the creation of new programming languages through a rich,
 expressive syntax system. Supplied languages include Typed Racket,
 ACL2, FrTime, and Lazy Racket, and R6RS Scheme.
 .
 Racket includes the DrRacket programming environment, a virtual
 machine with a just-in-time compiler, tools for creating stand-alone
 executables, the Racket web server, extensive libraries, and
 documentation for both beginners and experts.

Package: racket-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: racket (>= ${source:Upstream-Version})
            , racket-doc (>= ${source:Upstream-Version})
            , sensible-utils
Breaks: plt-scheme (<<5.0~), racket-doc (<<6.1~)
Replaces: plt-scheme (<<5.0~), racket-doc (<<6.1~)
Description: extensible programming language in the Scheme family (shared files)
 This package includes the architecture independent files for Racket
 (but not the documentation, see racket-doc for that).

Package: racket-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: racket (>= ${source:Upstream-Version})
Enhances: racket
Breaks: plt-scheme-doc (<<5.0~)
Replaces: plt-scheme-doc (<<5.0~)
Provides: plt-scheme-doc
Description: extensible programming language in the Scheme family (documentation)
 This package includes all of the documentation for Racket.
